#! /usr/bin/env python
# coding: utf-8

import gtk

def move_cursor(view, func):
    buff = view.get_buffer()
    it = buff.get_iter_at_mark(buff.get_insert())
    func(it)
    buff.place_cursor(it)
    view.grab_focus()

def fwd_word_cb(widget, view):
    move_cursor(view, gtk.TextIter.forward_word_end)

def bwd_word_cb(widget, view):
    move_cursor(view, gtk.TextIter.backward_word_start)

def buttons(view):
    box = gtk.HBox(spacing=5)
    button = gtk.Button('backward')
    button.connect('clicked', bwd_word_cb, view)
    box.pack_start(button)
    button = gtk.Button('forward')
    button.connect('clicked', fwd_word_cb, view)
    box.pack_start(button)
    return box

def main():
    window = gtk.Window(gtk.WINDOW_TOPLEVEL)
    window.set_title('Pango test')
    window.set_default_size(400, 300)
    window.connect('delete_event', gtk.main_quit)

    view = gtk.TextView()
    view.set_wrap_mode(gtk.WRAP_WORD)
    view.set_size_request(-1, 200)
    view.get_buffer().set_text("This is a test.  Shouldn't words like"
                               " \"shouldn't\" be considered one word?")
    scroll = gtk.ScrolledWindow()
    scroll.add(view)

    box = gtk.VBox(spacing=5)
    box.pack_start(scroll)
    box.pack_start(buttons(view))

    window.add(box)
    window.show_all()
    gtk.main()

main()
